"""
    Haqa's Patch Kit
    ====== ===== ===
    
    This kit contains a group of small patches, related only by the fact
    that they use my patch.py to apply themselves.
"""
__version__ = '4.0.0'

from os import listdir
from os.path import splitext
from Globals import package_home
from sys import modules
from Patch import applyPatch

banlist = ('__init__', 'Patch')
Patches = map(splitext, listdir(package_home(globals())))
Patches = filter(lambda (name, ext): (ext == '.py' and
                                      name not in banlist), Patches)
Patches = map(lambda (name, ext): name, Patches)
for item in Patches:
    if item in modules.keys():
        reload("Products.PatchKit.%s" % item)
    else:
        exec "import %s" % (item, )
    applyPatch(modules["Products.PatchKit.%s" % item])

def initialize(context):
    """ Init this product """
    for item in Patches:
        if hasattr(modules["Products.PatchKit.%s" % item], 'performPatch'):
            modules["Products.PatchKit.%s" % item].performPatch(
                context._ProductContext__app)
    context.registerHelpTitle("Haqa's Patch Kit")
    context.registerHelp()
